Attribute VB_Name = "Modul1"
Option Explicit

Public Sub Stueckliste_bereinigen()

    Dim Bezeichnung, ObjektID, ObjektID_neu As String
    Dim Laenge, Breite, Staerke As Single
        Dim i As Long, J As Long, Anzahl As Integer, Zeilenende As Long
    
    'Spalten umsortieren  und Anzahl anlegen *******************
    
    Range("H3").Select                   ' aus aufgezeichnetem Makro
    ActiveCell.FormulaR1C1 = "Stk."
    Columns("B:B").Select
    Selection.Cut
    Columns("J:J").Select
    ActiveSheet.Paste
    Columns("J:J").Select  ' Spalte ObjectID linksbndig setzen
    With Selection
        .HorizontalAlignment = xlLeft
        .VerticalAlignment = xlBottom
        .WrapText = False
        .Orientation = 0
        .AddIndent = False
        .IndentLevel = 0
        .ShrinkToFit = False
        .ReadingOrder = xlContext
        .MergeCells = False
    End With
 
    'Sub Spaltenbreiten_setzen()

    Columns("A:A").Select
    Selection.ColumnWidth = 5 '6.71
    Columns("B:B").ColumnWidth = 1
    Columns("C:C").ColumnWidth = 45
    Columns("D:D").ColumnWidth = 20
    Columns("E:E").ColumnWidth = 10
    Columns("F:F").ColumnWidth = 10
    Columns("G:G").ColumnWidth = 10
    Columns("H:H").ColumnWidth = 5
    Columns("I:I").ColumnWidth = 1
    Columns("J:J").ColumnWidth = 18
       
' Formatierung_Zeile Makro

    Cells.Select
    Selection.RowHeight = 19
    Range("A3:J3").Select
    Selection.Borders(xlDiagonalDown).LineStyle = xlNone
    Selection.Borders(xlDiagonalUp).LineStyle = xlNone
    Selection.Borders(xlEdgeLeft).LineStyle = xlNone
    Selection.Borders(xlEdgeTop).LineStyle = xlNone
    With Selection.Borders(xlEdgeBottom)
        .LineStyle = xlContinuous
        .ColorIndex = 0
        .TintAndShade = 0
        .Weight = xlThin
    End With
    Selection.Borders(xlEdgeRight).LineStyle = xlNone
    Selection.Borders(xlInsideVertical).LineStyle = xlNone
    Selection.Borders(xlInsideHorizontal).LineStyle = xlNone
    Range("E3:H3").Select
    With Selection
        .HorizontalAlignment = xlRight
        .VerticalAlignment = xlBottom
        .WrapText = False
        .Orientation = 0
        .AddIndent = False
        .IndentLevel = 0
        .ShrinkToFit = False
        .ReadingOrder = xlContext
        .MergeCells = False
    ' Stcklistenbezeichnung
         Range("A1").Select
         
         With Selection.Font
            .Size = 12
         End With
         
         Rows("2:2").RowHeight = 8
         
         ActiveCell.FormulaR1C1 = "Stckliste PlasmaSchlitten aus TurboCad - v?? - LP_" & Date
         'Range("H1").Select
         
        
      ' Datum eintragen Zelle J1
        
       ' ActiveCell.FormulaR1C1 = Now   ' "1/31/2018"
        
    
        
    End With
                  
    'Neue Spalte "Stk." alle auf 1 setzen *********************
    
    With ThisWorkbook.Sheets("Tabelle1")
        Zeilenende = .Cells(.Rows.Count, "C").End(xlUp).Row
          For i = 4 To Zeilenende
          Range("H" & i).Value = "1"
        Next i
    End With

            
    'gleiche Objekte addieren *************von jossie*************
    
    Range("C4").Activate
    i = 0
    Do
        Bezeichnung = ActiveCell.Offset(i, 0).Value
        Laenge = ActiveCell.Offset(i, 1).Value
        Breite = ActiveCell.Offset(i, 2).Value
        Staerke = ActiveCell.Offset(i, 3).Value
        ObjektID = ActiveCell.Offset(i, 7).Value
        
        J = 1
        Do
            If ActiveCell.Offset(i + J, 0).Value = Bezeichnung Then
                If ActiveCell.Offset(i + J, 1).Value = Laenge Then
                    If ActiveCell.Offset(i + J, 2).Value = Breite Then
                        If ActiveCell.Offset(i + J, 3).Value = Staerke Then
                            Anzahl = ActiveCell.Offset(i, 5).Value + 1
                            ActiveCell.Offset(i, 5).Value = Anzahl
                            ObjektID_neu = ObjektID & ", " & ActiveCell.Offset(i + J, 7).Value
                            ActiveCell.Offset(i, 7).Value = ObjektID_neu
                            ObjektID = ObjektID_neu
                            ActiveCell.Offset(i + J, 0).EntireRow.Delete Shift:=xlUp
                            J = J - 1
                        End If
                    End If
                End If
            End If
            J = J + 1
        Loop Until ActiveCell.Offset(i + J, 0).Value = ""
        i = i + 1
    Loop Until ActiveCell.Offset(i, 0).Value = ""
    
    ' Neue Tabelle A-Z sortieren **********************
    
    Range("C4:O400").Select
    ActiveWorkbook.Worksheets("Tabelle1").Sort.SortFields.Clear
    ActiveWorkbook.Worksheets("Tabelle1").Sort.SortFields.Add Key:=Range("C4:C400" _
        ), SortOn:=xlSortOnValues, Order:=xlAscending, DataOption:=xlSortNormal
    With ActiveWorkbook.Worksheets("Tabelle1").Sort
        .SetRange Range("C4:J400")
        .Header = xlGuess
        .MatchCase = False
        .Orientation = xlTopToBottom
        .SortMethod = xlPinYin
        .Apply
    End With
    
    ' Pos neu durchnummerieren ************************
    
     With ThisWorkbook.Sheets("Tabelle1")
       Zeilenende = .Cells(.Rows.Count, "C").End(xlUp).Row
       For i = 4 To Zeilenende
       Range("A" & i).Value = i - 3
       Next i
    End With

    ' Dateiname_einfgen Makro
    
    With ThisWorkbook.Sheets("Tabelle1")
      Zeilenende = .Cells(.Rows.Count, "C").End(xlUp).Row
      Range("C" & Zeilenende + 2).Select
      ActiveCell.FormulaR1C1 = "=CELL(""dateiname"")"
    End With
    
    ' Text Dateiname krzen und Schriftgre
    ActiveCell.Value = Mid(ActiveCell.Value, 17, 105)  '100
    With Selection.Font
        .Size = 6
    End With

' Spalte Stk nach C schieben
'
    Columns("H:H").Select
    Selection.Cut
    Columns("C:C").Select
    Selection.Insert Shift:=xlToRight
    Columns("D:D").Select
    Selection.Insert Shift:=xlToRight, CopyOrigin:=xlFormatFromLeftOrAbove
    Selection.ColumnWidth = 0.92
    Range("A1").Select

End Sub




